<script>
import { GlLabel, GlLink, GlButton } from '@gitlab/ui'
import copyToClipboard from '@/assets/copy-to-clipboard'
import getGitLabUrl from '@/assets/get-gitlab-url'
import { getTableauUrl } from '@/assets/utils'

export default {
  name: 'MdMetricCard',

  components: { GlLabel, GlLink, GlButton },

  props: {
    item: {
      type: Object,
      required: true,
    },
  },

  computed: {
    webPath() {
      return getGitLabUrl(this.item.web_path)
    },

    metric() {
      const { item } = this

      return [
        {
          label: 'Product group',
          value: `group::${item.product_group}`,
          type: 'GlLabel',
          props: { backgroundColor: '#6366F1' },
        },
        {
          label: 'Product categories',
          value: item.product_categories,
          type: 'GlLabelList',
        },
        {
          label: 'Metric Trend Dashboard',
          value: 'Link',
          type: 'GlLink',
          props: { href: getTableauUrl(item.key_path) },
        },
        {
          label: 'Associated Events',
          value: item.events
            ? item.events.map((event) => ({ name: event.name }))
            : null,
          type: 'GlLinkArray',
        },
        { label: 'Value type', value: item.value_type },
        { label: 'Status', value: item.status },
        { label: 'Time frame', value: item.time_frame },
        { label: 'Data source', value: item.data_source },
        { label: 'Data category', value: item.data_category },
        {
          label: 'Instrumentation class',
          value: item.instrumentation_class,
          type: 'GlLink',
          props: { href: item.instrumentation_class_link },
        },
        { label: 'Distribution', value: item.distribution },
        {
          label: 'Performance indicator type',
          value: item.performance_indicator_type,
        },
        {
          label: 'Tiers',
          value: Array.isArray(item.tiers) ? item.tiers : [],
          type: 'GlLabelList',
          props: { backgroundColor: '#FFE5E5' },
        },
        { label: 'Milestone', value: item.milestone },
        { label: 'Milestone removed', value: item.milestone_removed },
        {
          label: 'Introduced by url',
          value: item.introduced_by_url,
          type: 'GlLink',
          props: { href: item.introduced_by_url },
        },
        { label: 'Removed by url', value: item.removed_by_url },
        { label: 'Repair issue url', value: item.repair_issue_url },
        {
          label: 'Options',
          value: item.options ? Object.entries(item.options) : null,
          type: 'object',
        },
        {
          label: 'Snowflake query for GitLab.com',
          value: 'Copy query to clipboard',
          type: 'GlButton',
          props: {},
          on: {
            click: () => {
              copyToClipboard(item.gitlab_com_snowflake_query)
            },
          },
        },
        {
          label: 'Self Managed Snowflake Query',
          value: 'Copy query to clipboard',
          type: 'GlButton',
          props: {},
          on: {
            click: () => {
              copyToClipboard(item.self_managed_service_ping_snowflake_query)
            },
          },
        },
      ]
    },
  },
}
</script>

<template>
  <div
    class="overflow-hidden rounded-lg bg-white shadow-md ring-1 ring-gray-200/50"
  >
    <div class="px-4 py-5">
      <h3
        class="break-all font-mono text-lg font-medium leading-6 text-gray-900"
      >
        <a :href="webPath">{{ item.key_path }}</a>
      </h3>
      <p class="m-0 max-w-prose text-sm text-gray-500 sm:mt-1">
        {{ item.description }}
      </p>
    </div>
    <div class="border-t border-gray-200 px-4 pt-5 pb-2">
      <dl class="sm:divide-y sm:divide-gray-200">
        <div
          v-for="{ label, value, type, props, on } in metric"
          :key="label"
          class="items-center py-2.5 sm:grid sm:grid-cols-3 sm:gap-4 sm:px-4"
        >
          <dt class="text-sm font-medium text-gray-500">{{ label }}</dt>
          <dd class="m-0 sm:col-span-2">
            <span v-if="!value" class="text-gray-400">-</span>

            <gl-link
              v-else-if="type === 'GlLink'"
              target="_blank"
              v-bind="props"
            >
              {{ value }}
            </gl-link>

            <gl-button
              v-else-if="type === 'GlButton'"
              v-bind="props"
              v-on="on"
              >{{ value }}</gl-button
            >

            <gl-label
              v-else-if="type === 'GlLabel'"
              :title="value"
              v-bind="props"
              scoped
            />

            <div v-else-if="type === 'GlLinkArray' && value">
              <span v-for="(event, idx) in value" :key="event.name">
                <gl-link :href="`/events?action=${event.name}`" class="gl-link">
                  {{ event.name }}
                </gl-link>
                <span v-if="idx < value.length - 1">, </span>
              </span>
            </div>

            <div
              v-else-if="type === 'GlLabelList' && Array.isArray(value)"
              class="label-list"
            >
              <span v-for="labelTitle in value" :key="labelTitle">
                <gl-label
                  :background-color="props.backgroundColor"
                  :title="labelTitle"
                />
              </span>
            </div>

            <div v-else-if="type === 'object'" class="overflow-x-auto text-sm">
              <lazy-md-card-object
                v-for="[optionLabel, optionValue] in value"
                :key="optionValue.toString()"
                :label="optionLabel"
                :value="optionValue"
              />
            </div>

            <div v-else class="m-0 text-sm text-gray-900">{{ value }}</div>
          </dd>
        </div>
      </dl>
    </div>
  </div>
</template>

<style>
.gl-label-link {
  pointer-events: none;
}
</style>
